Index: trunk/gli/src/org/greenstone/gatherer/Gatherer.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/Gatherer.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/Gatherer.java	(revision 10726)
@@ -47,4 +47,5 @@
 import org.greenstone.gatherer.gui.URLField;
 import org.greenstone.gatherer.gui.WarningDialog;
+import org.greenstone.gatherer.remote.RemoteGreenstoneServer;
 import org.greenstone.gatherer.util.JarTools;
 import org.greenstone.gatherer.util.StaticStrings;
@@ -93,5 +94,4 @@
     static public boolean isApplet = false;
     static public boolean isGsdlRemote = false;
-    static public String cgiBase = null;
 
     // feedback stuff
@@ -293,5 +293,4 @@
 		if (Configuration.gliserver_url != null) {
 		    gliserver_url_string = Configuration.gliserver_url.toString();
-		    cgiBase = gliserver_url_string.substring(0, gliserver_url_string.lastIndexOf('/') + 1);
 		}
 	    }
@@ -508,4 +507,9 @@
 	if (LocalLibraryServer.isRunning() == true) {
 	    LocalLibraryServer.stop();
+	}
+
+	// If we're using a remote Greenstone server we need to make sure that all jobs have completed first
+	if (isGsdlRemote) {
+	    RemoteGreenstoneServer.exit();
 	}
 
Index: trunk/gli/src/org/greenstone/gatherer/GathererApplet.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/GathererApplet.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/GathererApplet.java	(revision 10726)
@@ -123,4 +123,5 @@
 			  "-gliserver_url", gliserver_url_string,
 			  "-library_url", library_url_string,
+			  "-debug",
 	                };
 
@@ -133,5 +134,5 @@
 		//   for documented example collections so "base this on
 		//   existing collection" works
-		ZipTools.unzipFromJar("collect.zip", Gatherer.getGLIUserDirectoryPath());
+		unzipFromJar("collect.zip", Gatherer.getGLIUserDirectoryPath());
 	    }
 	    else {
@@ -146,5 +147,5 @@
 	if (!metadata_directory.exists()) {
 	    // dig out metadata.zip from JAR file and unzip it
-	    ZipTools.unzipFromJar("metadata.zip", Gatherer.getGLIDirectoryPath());
+	    unzipFromJar("metadata.zip", Gatherer.getGLIDirectoryPath());
 	}
 
@@ -159,5 +160,4 @@
 
 
-
     public void start() 
     {
@@ -166,5 +166,4 @@
 
 
-
     public void stop()
     {
@@ -172,4 +171,5 @@
 
     }
+
 
     public void destroy()
@@ -186,5 +186,34 @@
 
 	// If there was an open collection last session, reopen it
-	Gatherer.c_man.openCollectionFromLastTime();
+	new OpenCollectionFromLastTimeTask().start();
+    }
+
+
+    /** This is in it's own thread because this action cannot happen on the GUI thread. */
+    private class OpenCollectionFromLastTimeTask
+	extends Thread
+    {
+	public void run()
+	{
+	    Gatherer.c_man.openCollectionFromLastTime();
+	}
+    }
+
+
+    /** 
+     * Method which unzips a given metadata resoure.
+     * @param jar_zip_fname The name of the jar file as a <strong>String</strong>.
+     * @param dst_dir The destination directory for unzipping, also as a <strong>String</strong>.
+     * @see JarTools.extractFromJar(String, String, boolean)
+     */
+    static public void unzipFromJar(String jar_zip_fname, String dst_dir)
+    {
+	if (!dst_dir.endsWith(File.separator)) {
+	    dst_dir += File.separator;
+	}
+
+	// !! TO DO: Test this !!
+	JarTools.extractFromJar(jar_zip_fname, dst_dir, true);
+	ZipTools.unzipFile(dst_dir + jar_zip_fname, dst_dir);
     }
 }
Index: trunk/gli/src/org/greenstone/gatherer/cdm/ClassifierManager.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/cdm/ClassifierManager.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/cdm/ClassifierManager.java	(revision 10726)
@@ -43,4 +43,5 @@
 import org.greenstone.gatherer.gui.GComboBox;
 import org.greenstone.gatherer.gui.GLIButton;
+import org.greenstone.gatherer.remote.RemoteGreenstoneServer;
 import org.greenstone.gatherer.util.JarTools;
 import org.greenstone.gatherer.util.StaticStrings;
@@ -311,15 +312,6 @@
 	    StringBuffer xml = null;
 	    if (Gatherer.isGsdlRemote) {
-		String launch  = Gatherer.cgiBase + "launch";
-		launch += "?cmd=classinfo.pl";
-		launch += "&xml=&language="+lang;
-		launch += "&class=" + getClassifierName(classifier);
-		
-		System.err.println("*** launch = " + launch);
-		
-		URL launch_url = new URL(launch);
-		URLConnection launch_connection = launch_url.openConnection();
-		input_stream = launch_connection.getInputStream();
-		xml = Utility.readXMLStream(input_stream);
+		String classinfo_output = RemoteGreenstoneServer.getScriptOptions("classinfo.pl", "&classifier=" + classifier);
+		xml = new StringBuffer(classinfo_output);
 	    }
 	    else {
@@ -386,29 +378,9 @@
 
 	    if (Gatherer.isGsdlRemote) {
-
-		String lang = Configuration.getLanguage();
-
-		String launch  = Gatherer.cgiBase + "launch";
-		launch += "?cmd=classinfo.pl";
-		launch += "&xml=&language="+lang;
-		launch += "&listall=";
-
-		System.err.println("*** launch = " + launch);
-
-		try {
-		    URL launch_url = new URL(launch);
-		    URLConnection launch_connection = launch_url.openConnection();
-		    InputStream input_stream = launch_connection.getInputStream();
-		    StringBuffer xml = Utility.readXMLStream(input_stream);
-		    loadClassifiers(xml);
-		}
-		catch (Exception error) {
-		    System.err.println("Failed when trying to connect to : " + launch);
-		    error.printStackTrace();
-		}
-
-	    }
+		String classinfo_output = RemoteGreenstoneServer.getScriptOptions("classinfo.pl", "&listall=");
+		loadClassifiers(new StringBuffer(classinfo_output));
+	    }
+
 	    else {
-
 		// Retrieve the gsdl home directory...
 		String directory = LocalGreenstone.getDirectoryPath();
Index: trunk/gli/src/org/greenstone/gatherer/cdm/CollectionConfiguration.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/cdm/CollectionConfiguration.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/cdm/CollectionConfiguration.java	(revision 10726)
@@ -511,6 +511,5 @@
 		if (Gatherer.isGsdlRemote) {
 		    String collection_name = Gatherer.c_man.getCollection().getName();
-		    ZipTools.zipup(Gatherer.getCollectDirectoryPath(), collection_name, "collect.cfg", null, "", "");
-		    RemoteGreenstoneServer.upload_url_zip(collection_name, "etc", "", null);
+		    RemoteGreenstoneServer.uploadCollectionFile(collection_name, collect_cfg_file);
 		}
 	    }
Index: trunk/gli/src/org/greenstone/gatherer/cdm/PluginManager.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/cdm/PluginManager.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/cdm/PluginManager.java	(revision 10726)
@@ -47,4 +47,5 @@
 import org.greenstone.gatherer.gui.ModalDialog;
 import org.greenstone.gatherer.gui.WarningDialog;
+import org.greenstone.gatherer.remote.RemoteGreenstoneServer;
 import org.greenstone.gatherer.util.JarTools;
 import org.greenstone.gatherer.util.StaticStrings;
@@ -443,15 +444,6 @@
 	    StringBuffer xml = null;
 	    if (Gatherer.isGsdlRemote) {
-		String launch  = Gatherer.cgiBase + "launch";
-		launch += "?cmd=pluginfo.pl";
-		launch += "&xml=&language="+lang;
-		launch += "&plug=" + getPluginName(plugin);
-		
-		System.err.println("*** launch = " + launch);
-		
-		URL launch_url = new URL(launch);
-		URLConnection launch_connection = launch_url.openConnection();
-		input_stream = launch_connection.getInputStream();
-		xml = Utility.readXMLStream(input_stream);
+		String pluginfo_output = RemoteGreenstoneServer.getScriptOptions("pluginfo.pl", "&plugin=" + plugin);
+		xml = new StringBuffer(pluginfo_output);
 	    }
 	    else {
@@ -514,28 +506,10 @@
 	if(library == null) {
 	    library = new ArrayList();
+
 	    if (Gatherer.isGsdlRemote) {
-
-		String lang = Configuration.getLanguage();
-
-		String launch  = Gatherer.cgiBase + "launch";
-		launch += "?cmd=pluginfo.pl";
-		launch += "&xml=&language="+lang;
-		launch += "&listall=";
-
-		System.err.println("*** launch = " + launch);
-
-		try {
-		    URL launch_url = new URL(launch);
-		    URLConnection launch_connection = launch_url.openConnection();
-		    InputStream input_stream = launch_connection.getInputStream();
-		    StringBuffer xml = Utility.readXMLStream(input_stream);
-		    loadPlugins(xml);
-		}
-		catch (Exception error) {
-		    System.err.println("Failed when trying to connect to : " + launch);
-		    error.printStackTrace();
-		}
-
-	    }
+		String pluginfo_output = RemoteGreenstoneServer.getScriptOptions("pluginfo.pl", "&listall=");
+		loadPlugins(new StringBuffer(pluginfo_output));
+	    }
+
 	    else {
 		// Retrieve the gsdl home directory...
Index: trunk/gli/src/org/greenstone/gatherer/collection/CollectionManager.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/collection/CollectionManager.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/collection/CollectionManager.java	(revision 10726)
@@ -100,4 +100,7 @@
     private GShellProgressMonitor import_monitor = null;
 
+    /** Whether we have downloaded the collection configurations in this session, when using a remote Greenstone. */
+    static public boolean downloaded_collection_configurations = false;
+
     /** The name of the standard lock file. */
     static final public String LOCK_FILE = "gli.lck";
@@ -117,7 +120,10 @@
 	MetadataXMLFileManager.addMetadataChangedListener(this);
 
-	// If using a remote Greenstone server, download the collection configurations
+	// If using a remote Greenstone server, delete the local collect directory because it will be out of date
 	if (Gatherer.isGsdlRemote) {
-	    RemoteGreenstoneServer.downloadCollectionConfigurations();
+	    System.err.println("Deleting user's local collect directory...");
+	    Utility.delete(new File(Gatherer.getCollectDirectoryPath()));
+	    System.err.println("Done.");
+	    new File(Gatherer.getCollectDirectoryPath()).mkdirs();
 	}
     }
@@ -142,5 +148,6 @@
     public void buildCollection(boolean incremental_build)
     {
-	DebugStream.println("In CollectionManager.buildCollection(), incremental_build: " + incremental_build);
+	System.err.println("In CollectionManager.buildCollection(), incremental_build: " + incremental_build);
+	System.err.println("Is event dispatch thread: " + SwingUtilities.isEventDispatchThread());
 	building = true;
 
@@ -175,5 +182,5 @@
 	shell.addGShellListener(Gatherer.g_man.create_pane);
 	shell.start();
-	DebugStream.println("CollectionManager.buildCollection().return");
+	System.err.println("CollectionManager.buildCollection().return");
     }
 
@@ -217,4 +224,9 @@
 	if (lock_file.exists()) {
 	    System.err.println("Warning: Lockfile was not successfully deleted.");
+	}
+
+	// Remove the lock file on the server
+	if (Gatherer.isGsdlRemote) {
+	    RemoteGreenstoneServer.deleteCollectionFile(collection.getName(), lock_file);
 	}
 
@@ -665,5 +677,6 @@
 	}
 
-	DebugStream.println("CollectionManager.importCollection()");
+	System.err.println("CollectionManager.importCollection()");
+	System.err.println("Is event dispatch thread: " + SwingUtilities.isEventDispatchThread());
 	//check that we can remove the old index before starting import
 	File index_dir = new File(getCollectionIndexDirectoryPath());
@@ -709,5 +722,5 @@
 	shell.addGShellListener(Gatherer.g_man.create_pane);
 	shell.start();
-	DebugStream.println("CollectionManager.importCollection().return");
+	System.err.println("CollectionManager.importCollection().return");
 
 	importing = false;
@@ -798,5 +811,5 @@
 	if (Gatherer.isGsdlRemote) {
 	    String collection_name = location.substring(location.lastIndexOf(File.separator) + 1, location.length() - ".col".length());
-	    if (!RemoteGreenstoneServer.downloadCollection(collection_name)) {
+	    if (RemoteGreenstoneServer.downloadCollection(collection_name).equals("")) {
 		return;
 	    }
@@ -994,9 +1007,14 @@
     {
 	// If there was an open collection last session, reopen it
-	if (Gatherer.open_collection_file_path != null) {
+	if (Gatherer.open_collection_file_path != null && !Gatherer.isGsdlRemote) {
 	    // If we're using a remote Greenstone server we must download the collection configurations first
-	    if (Gatherer.isGsdlRemote) {
-		RemoteGreenstoneServer.downloadCollectionConfigurations();
-	    }
+	    // if (Gatherer.isGsdlRemote && !CollectionManager.downloaded_collection_configurations) {
+	    // if (RemoteGreenstoneServer.downloadCollectionConfigurations().equals("")) {
+		    // Something went wrong downloading the collection configurations
+		    // return;
+	    // }
+
+	    // CollectionManager.downloaded_collection_configurations = true;
+	    // }
 
 	    // Load the collection now
@@ -1025,5 +1043,5 @@
      */
     public synchronized void processComplete(GShellEvent event) {
-	DebugStream.println("CollectionManager.processComplete(" + event.getType() + ")");
+	System.err.println("CollectionManager.processComplete(" + event.getType() + ")");
 	Gatherer.g_man.lockCollection((event.getType() == GShell.IMPORT), false);
 	///ystem.err.println("Recieved process complete event - " + event);
@@ -1267,4 +1285,9 @@
 			throw new Exception(Dictionary.get("CollectionManager.Index_Not_Deleted"));
 		    }
+		}
+
+		if (Gatherer.isGsdlRemote) {
+		    RemoteGreenstoneServer.deleteCollectionFile(collection.getName(), new File(getCollectionIndexDirectoryPath()));
+		    RemoteGreenstoneServer.moveCollectionFile(collection.getName(), new File(getCollectionBuildingDirectoryPath()), new File(getCollectionIndexDirectoryPath()));
 		}
 
Index: trunk/gli/src/org/greenstone/gatherer/collection/ScriptOptions.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/collection/ScriptOptions.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/collection/ScriptOptions.java	(revision 10726)
@@ -11,4 +11,5 @@
 import org.greenstone.gatherer.LocalGreenstone;
 import org.greenstone.gatherer.cdm.Argument;
+import org.greenstone.gatherer.remote.RemoteGreenstoneServer;
 import org.greenstone.gatherer.util.ArrayTools;
 import org.greenstone.gatherer.util.Codec;
@@ -291,14 +292,6 @@
 	    Document document;
 	    if (Gatherer.isGsdlRemote) {
-		String launch  = Gatherer.cgiBase + "launch";
-		launch += "?cmd=" + filename;
-		launch += "&xml=&language="+lang;
-
-		System.err.println("*** launch = " + launch);
-
-		URL launch_url = new URL(launch);
-		URLConnection launch_connection = launch_url.openConnection();
-		input_stream = launch_connection.getInputStream();
-		document = XMLTools.parseXML(input_stream);
+		String script_output = RemoteGreenstoneServer.getScriptOptions(filename, "");
+		document = XMLTools.parseXML(new StringReader(script_output));
 	    }
 	    else {
Index: trunk/gli/src/org/greenstone/gatherer/file/FileManager.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/file/FileManager.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/file/FileManager.java	(revision 10726)
@@ -174,4 +174,5 @@
 		    // Perform the appropriate action based on the job type (RemoteGreenstoneServer will queue)
 		    if (type == FileJob.COPY) {
+			// Copies: upload all the files at once in one zip file
 			File[] source_files = new File[source_nodes.length];
 			for (int i = 0; i < source_nodes.length; i++) {
@@ -181,8 +182,14 @@
 		    }
 		    else if (type == FileJob.DELETE) {
-			RemoteGreenstoneServer.deleteCollectionFile(collection_name, source_nodes[0].getFile());
+			// Deletes: delete each top-level file/directory one at a time
+			for (int i = 0; i < source_nodes.length; i++) {
+			    RemoteGreenstoneServer.deleteCollectionFile(collection_name, source_nodes[i].getFile());
+			}
 		    }
 		    else if (type == FileJob.MOVE) {
-			RemoteGreenstoneServer.moveCollectionFile(collection_name, source_nodes[0].getFile(), target_node.getFile());
+			// Moves: move each top-level file/directory one at a time
+			for (int i = 0; i < source_nodes.length; i++) {
+			    RemoteGreenstoneServer.moveCollectionFile(collection_name, source_nodes[i].getFile(), target_node.getFile());
+			}
 		    }
 		}
@@ -218,5 +225,8 @@
 		// ... but only if it is inside the collection and we haven't already downloaded it
 		if (file.getAbsolutePath().startsWith(Gatherer.getCollectDirectoryPath()) && file.length() == 0) {
-		    RemoteGreenstoneServer.downloadCollectionFile(Gatherer.c_man.getCollection().getName(), file);
+		    if (RemoteGreenstoneServer.downloadCollectionFile(Gatherer.c_man.getCollection().getName(), file).equals("")) {
+			// Something has gone wrong downloading the file
+			return;
+		    }
 		}
 	    }
@@ -239,55 +249,84 @@
 
     protected void newFolderOrDummyDoc(DragTree tree, CollectionTreeNode parent_node, int type) {
-	// Ask the user for the directories name.
-	String extension = "";
-	if (type == FILE_TYPE) {
-	    extension = ".nul";
-	}
-	NewFolderOrFilePrompt new_folder_prompt = new NewFolderOrFilePrompt(parent_node, type, extension);
-	String name = new_folder_prompt.display();
-	new_folder_prompt.dispose();
-	new_folder_prompt = null;
-	// And if the name is non-null...
-	if(name != null) {
-	    FileSystemModel model = (FileSystemModel) tree.getModel();
-	    File folder_file = new File(parent_node.getFile(), name);
-	    //... check if it already exists.
-	    if(folder_file.exists()) { 
-		if (type == FILE_TYPE) {
-		    JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("FileActions.File_Already_Exists_No_Create", name), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
-		} else {
-		    JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("FileActions.Folder_Already_Exists", name), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
-		}
-	    }
-	    // Otherwise create it.
-	    else {
-		try {
+	(new NewFolderOrDummyDocumentTask(tree, parent_node, type)).start();
+    }
+
+
+    private class NewFolderOrDummyDocumentTask
+	extends Thread
+    {
+	private DragTree tree = null;
+	private CollectionTreeNode parent_node = null;
+	private int type;
+
+	public NewFolderOrDummyDocumentTask(DragTree tree, CollectionTreeNode parent_node, int type)
+	{
+	    this.tree = tree;
+	    this.parent_node = parent_node;
+	    this.type = type;
+	}
+
+	public void run()
+	{
+	    // Ask the user for the directories name.
+	    String extension = "";
+	    if (type == FILE_TYPE) {
+		extension = ".nul";
+	    }
+
+	    NewFolderOrFilePrompt new_folder_prompt = new NewFolderOrFilePrompt(parent_node, type, extension);
+	    String name = new_folder_prompt.display();
+	    new_folder_prompt.dispose();
+	    new_folder_prompt = null;
+
+	    // And if the name is non-null...
+	    if (name != null) {
+		FileSystemModel model = (FileSystemModel) tree.getModel();
+		File folder_file = new File(parent_node.getFile(), name);
+
+		//... check if it already exists.
+		if (folder_file.exists()) { 
 		    if (type == FILE_TYPE) {
-			folder_file.createNewFile();
-		    } else {
-			folder_file.mkdirs();
-			if (Gatherer.isGsdlRemote) {
-			    long id = System.currentTimeMillis();
-			    RemoteGreenstoneServer.newCollectionDirectory(Gatherer.c_man.getCollection().getName(), folder_file);
-			}
-		    }
-		    // Update the parent node to show the new folder
-		    parent_node.refresh();
-		    
-		    // Refresh workspace tree (collection tree is done automatically)
-		    Gatherer.g_man.refreshWorkspaceTree(DragTree.COLLECTION_CONTENTS_CHANGED);
-		} catch (Exception e) {
-		    if (type == FILE_TYPE) {
-			JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("FileActions.File_Create_Error", name), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
-		    } else {
-			JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("FileActions.Folder_Create_Error", name), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
-		    }
-		}
-	    }
+			JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("FileActions.File_Already_Exists_No_Create", name), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
+		    }
+		    else {
+			JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("FileActions.Folder_Already_Exists", name), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
+		    }
+		}
+		// Otherwise create it.
+		else {
+		    try {
+			if (type == FILE_TYPE) {
+			    folder_file.createNewFile();
+			}
+			else {
+			    folder_file.mkdirs();
+			    if (Gatherer.isGsdlRemote) {
+				long id = System.currentTimeMillis();
+				RemoteGreenstoneServer.newCollectionDirectory(Gatherer.c_man.getCollection().getName(), folder_file);
+			    }
+			}
+
+			// Update the parent node to show the new folder
+			parent_node.refresh();
+
+			// Refresh workspace tree (collection tree is done automatically)
+			Gatherer.g_man.refreshWorkspaceTree(DragTree.COLLECTION_CONTENTS_CHANGED);
+		    }
+		    catch (Exception exception) {
+			if (type == FILE_TYPE) {
+			    JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("FileActions.File_Create_Error", name), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
+			}
+			else {
+			    JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("FileActions.Folder_Create_Error", name), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
+			}
+		    }
+		}
 		
-	    folder_file = null;
-	    model = null;
-	}
-	name = null;
+		folder_file = null;
+		model = null;
+	    }
+	    name = null;
+	}
     }
 }
Index: trunk/gli/src/org/greenstone/gatherer/gui/CreatePane.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/gui/CreatePane.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/gui/CreatePane.java	(revision 10726)
@@ -537,4 +537,5 @@
      */
     public synchronized void processComplete(GShellEvent event) {
+	System.err.println("In CreatePane::processComplete(" + event.getType() + ")...");
 	if(event.getStatus() == GShell.OK) {
 	    if(event.getType() == GShell.BUILD) {
Index: trunk/gli/src/org/greenstone/gatherer/gui/DeleteCollectionPrompt.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/gui/DeleteCollectionPrompt.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/gui/DeleteCollectionPrompt.java	(revision 10726)
@@ -50,4 +50,5 @@
 import org.greenstone.gatherer.collection.BasicCollectionConfiguration;
 import org.greenstone.gatherer.file.WorkspaceTree;  // !!! Don't like this here
+import org.greenstone.gatherer.remote.RemoteGreenstoneServer;
 import org.greenstone.gatherer.util.ArrayTools;
 import org.greenstone.gatherer.util.StaticStrings;
@@ -293,4 +294,5 @@
 	public void actionPerformed(ActionEvent event) {
 	    // Delete the selected collection.
+	    // !! This should all go into CollectionManager !!
 
 	    // First we must release it from the local library
@@ -300,39 +302,5 @@
 
 	    if (Gatherer.isGsdlRemote) {
-				
-		String launch_cgi  = Gatherer.cgiBase + "launch?cmd=deldir";
-
-		String col_name = collection.getShortName();
-		String dir = ".";
-
-		try {
-
-		    String col_name_encoded = URLEncoder.encode(col_name,"UTF-8");
-		    String dir_encoded = URLEncoder.encode(dir,"UTF-8");
-
-		    launch_cgi += "&c=" + col_name_encoded;
-		    launch_cgi += "&dir=" + dir_encoded;
-		
-		    URL launch_url = new URL(launch_cgi);
-		    URLConnection launch_connection = launch_url.openConnection();
-		    InputStream stdis = launch_connection.getInputStream();
-		    InputStreamReader stdisr = new InputStreamReader(stdis, "UTF-8"  );
-		    
-		    BufferedReader stdbr = new BufferedReader(stdisr);
-		    
-		    while(true) {
-			String line = stdbr.readLine();
-			// ignore output of running lauch command
-			
-			if (line == null) { break; }
-		    }		
-		    
-		    stdbr.close();
-		}
-		// Exception
-		catch (Exception exception) {
-		    DebugStream.println("Exception in GShell.runRemove() - unexpected");
-		    DebugStream.printStackTrace(exception);
-		}
+		RemoteGreenstoneServer.deleteCollection(collection.getShortName());
 	    }
 
Index: trunk/gli/src/org/greenstone/gatherer/gui/GUIManager.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/gui/GUIManager.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/gui/GUIManager.java	(revision 10726)
@@ -54,4 +54,5 @@
 import org.greenstone.gatherer.Gatherer;
 import org.greenstone.gatherer.collection.Collection;
+import org.greenstone.gatherer.collection.CollectionManager;
 import org.greenstone.gatherer.file.FileOpenActionListener;
 import org.greenstone.gatherer.file.WorkspaceTree;
@@ -394,4 +395,15 @@
 	    content_pane.add(tab_pane, BorderLayout.CENTER);
 
+	    // Add an extra progress bar at the bottom of every screen when using a remote Greenstone server
+	    if (Gatherer.isGsdlRemote) {
+		JPanel remote_greenstone_server_progress_panel = new JPanel();
+		JLabel remote_greenstone_server_progress_label = new JLabel(Dictionary.get("RemoteGreenstoneServer.Progress"));
+		remote_greenstone_server_progress_panel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
+		remote_greenstone_server_progress_panel.setLayout(new BorderLayout());
+		remote_greenstone_server_progress_panel.add(remote_greenstone_server_progress_label, BorderLayout.WEST);
+		remote_greenstone_server_progress_panel.add(RemoteGreenstoneServer.getProgressBar(), BorderLayout.CENTER);
+		content_pane.add(remote_greenstone_server_progress_panel, BorderLayout.SOUTH);
+	    }
+
 	    // Call refresh to update all controls to reflect current collection status.
 	    refresh(-1, Gatherer.c_man.ready());
@@ -641,12 +653,11 @@
 	{
 	    // If using a remote Greenstone check if the collection configurations have been downloaded; do so if not
-	    if (Gatherer.isGsdlRemote) {
-		File collect_directory = new File(Gatherer.getCollectDirectoryPath());
-		if (!collect_directory.exists() || collect_directory.listFiles().length == 0) {
-		    if (!RemoteGreenstoneServer.downloadCollectionConfigurations()) {
-			// Something went wrong downloading the collection configurations
-			return;
-		    }
-		}
+	    if (Gatherer.isGsdlRemote && !CollectionManager.downloaded_collection_configurations) {
+		if (RemoteGreenstoneServer.downloadCollectionConfigurations().equals("")) {
+		    // Something went wrong downloading the collection configurations
+		    return;
+		}
+
+		CollectionManager.downloaded_collection_configurations = true;
 	    }
 
@@ -712,6 +723,16 @@
 	public void run()
 	{
+	    // If using a remote Greenstone check if the collection configurations have been downloaded; do so if not
+	    if (Gatherer.isGsdlRemote && !CollectionManager.downloaded_collection_configurations) {
+		if (RemoteGreenstoneServer.downloadCollectionConfigurations().equals("")) {
+		    // Something went wrong downloading the collection configurations
+		    return;
+		}
+
+		CollectionManager.downloaded_collection_configurations = true;
+	    }
+
+	    // Create the collection details prompt from new collection prompt
 	    NewCollectionMetadataPrompt ncm_prompt = null;
-	    // Create the collection details prompt from new collection prompt
 	    NewCollectionDetailsPrompt ncd_prompt = new NewCollectionDetailsPrompt();
 	    // If no previous collection was indicated as a model design, then show the metadata selection prompt from new collection prompt
Index: trunk/gli/src/org/greenstone/gatherer/gui/GatherPane.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/gui/GatherPane.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/gui/GatherPane.java	(revision 10726)
@@ -602,4 +602,5 @@
 		    explode_metadata_database = new JMenuItem(Dictionary.get("Menu.Explode_Metadata_Database"), KeyEvent.VK_E);
 		    explode_metadata_database.addActionListener(this);
+		    explode_metadata_database.setEnabled(!Gatherer.isGsdlRemote);
 		    add(explode_metadata_database);
 		}
Index: trunk/gli/src/org/greenstone/gatherer/gui/MenuBar.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/gui/MenuBar.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/gui/MenuBar.java	(revision 10726)
@@ -97,4 +97,5 @@
 	file_cdimage = new JMenuItem();
 	file_cdimage.addActionListener(Gatherer.g_man);
+	file_cdimage.setEnabled(!Gatherer.isGsdlRemote);
 	file_cdimage.setMnemonic(KeyEvent.VK_I);
 	Dictionary.registerText(file_cdimage, "Menu.File_CDimage");
@@ -118,4 +119,5 @@
 	file_exportas = new JMenuItem();
 	file_exportas.addActionListener(Gatherer.g_man);
+	file_exportas.setEnabled(!Gatherer.isGsdlRemote);
 	file_exportas.setMnemonic(KeyEvent.VK_E);
 	Dictionary.registerText(file_exportas, "Menu.File_ExportAs");
Index: trunk/gli/src/org/greenstone/gatherer/gui/NewCollectionDetailsPrompt.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/gui/NewCollectionDetailsPrompt.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/gui/NewCollectionDetailsPrompt.java	(revision 10726)
@@ -221,11 +221,4 @@
 	// Retrieve the first 8 non-whitespace characters of title_final.
 	StringBuffer name_buffer = new StringBuffer("");
-
-	if (Gatherer.isGsdlRemote) {
-	    String username = System.getProperty("user.name");
-	    if ((username != null) && (username != "")) {
-		name_buffer.append(username + "-");
-	    }
-	}
 
 	int i = 0;
